---
title: XRSession.requestAnimationFrame()
slug: Web/API/XRSession/requestAnimationFrame
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRSession
  - requestAnimationFrame()
---
<div>{{securecontext_header}}{{APIRef("WebXR")}}</div>

<p><span class="seoSummary">The {{domxref("XRSession")}} method <code><strong>requestAnimationFrame()</strong></code>, much like the {{domxref("Window")}} method of the same name, schedules a callback to be executed the next time the browser is ready to paint the session's virtual environment to the XR display.</span> The specified callback is executed once before the next repaint; if you wish for it to be executed for the following repaint, you must call <code>requestAnimationFrame()</code> again. This can be done from within the callback itself.</p>

<p>The callback takes two parameters as inputs: an {{DOMxRef("XRFrame")}} describing the state of all tracked objects for the session, and a time stamp you can use to compute any animation updates needed.</p>

<p>You can cancel a previously scheduled animation by calling {{DOMxRef("XRSession.cancelAnimationFrame", "cancelAnimationFrame()")}}.</p>

<div class="notecard warning">
<p><strong>Note:</strong> Despite the obvious similarities between these methods and the global {{domxref("Window.requestAnimationFrame", "requestAnimationFrame()")}} function provided by the <code>Window</code> interface, you <em>must not</em> treat these as interchangeable. There is <em>no</em> guarantee that the latter will work at all while an immersive XR session is underway.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>requestID</em> = <em>xrSession</em>.requestAnimationFrame(<em>animationFrameCallback</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>animationFrameCallback</code></dt>
 <dd>
 <p>A function which is called before the next repaint in order to allow you to update and render the XR scene based on elapsed time, animation, user input changes, and so forth. The callback receives as input two parameters:</p>

 <dl>
  <dt><code>time</code></dt>
  <dd>A {{domxref("DOMHighResTimeStamp")}} indicating the time offset at which the updated viewer state was received from the WebXR device.</dd>
  <dt><code>xrFrame</code></dt>
  <dd>An {{domxref("XRFrame")}} object describing the state of the objects being tracked by the session. This can be used to obtain the poses of the viewer and the scene itself, as well as other information needed to render a frame of an AR or VR scene.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An integer value which serves as a unique, non-zero ID or handle you may pass to {{domxref("XRSession.cancelAnimationFrame", "cancelAnimationFrame()")}} if you need to remove the pending animation frame request.</p>

<h2 id="Example">Example</h2>

<p>The following example requests <code>XRSession</code> with "inline" mode so that it can be displayed in an HTML element (without the need for a separate AR or VR device).</p>

<div class="notecard note">
<p><strong>Note:</strong> A real application should check that the device and the User Agent support WebXR API at all and then that they both support the desired session type via {{DOMxRef("XR.isSessionSupported()")}}.</p>
</div>

<pre class="brush: js">// Obtain XR object
const XR = navigator.xr

// Request a new XRSession
XR.requestSession("inline").then((xrSession) =&gt; {
  xrSession.requestAnimationFrame((time, xrFrame) =&gt; {
    let viewer = xrFrame.getViewerPose(xrReferenceSpace)

    gl.bindFramebuffer(xrWebGLLayer.framebuffer)
    for (xrView of viewer.views) {
      let xrViewport = xrWebGLLayer.getViewport(xrView)
      gl.viewport(xrViewport.x, xrViewport.y, xrViewport.width, xrViewport.height)

    // WebGL draw calls will now be rendered into the appropriate viewport.
    }
  })
})
</pre>

<p>The following example was taken directly from the spec draft. This example demonstrates a design pattern that ensures seamless transition between non-immersive animations created via {{DOMxRef("Window.requestAnimationFrame")}} and immersive XR animations.</p>

<pre class="brush: js">let xrSession = null

function onWindowAnimationFrame(time) {
  window.requestAnimationFrame(onWindowAnimationFrame)

  // This may be called while an immersive session is running on some devices,
  // such as a desktop with a tethered headset. To prevent two loops from
  // rendering in parallel, skip drawing in this one until the session ends.
  if (!xrSession) {
    renderFrame(time, null)
  }
}

// The window animation loop can be started immediately upon the page loading.
window.requestAnimationFrame(onWindowAnimationFrame)

function onXRAnimationFrame(time, xrFrame) {
  xrSession.requestAnimationFrame(onXRAnimationFrame)
  renderFrame(time, xrFrame)
}

function renderFrame(time, xrFrame) {
  // Shared rendering logic.
}

// Assumed to be called by a user gesture event elsewhere in code.
function startXRSession() {
  navigator.xr.requestSession('immersive-vr').then((session) =&gt; {
    xrSession = session
    xrSession.addEventListener('end', onXRSessionEnded)
    // Do necessary session setup here.
    // Begin the session’s animation loop.
    xrSession.requestAnimationFrame(onXRAnimationFrame)
  })
}

function onXRSessionEnded() {
  xrSession = null
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-requestanimationframe","XRSession.requestAnimationFrame")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.requestAnimationFrame")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Window.requestAnimationFrame()")}}</li>
 <li>{{domxref("XRSession.cancelAnimationFrame()")}}</li>
</ul>
